routes/admin.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware' => ['auth', 'app.menu']], function () {    
    Route::resource('users', 'Admin\UserController');
    Route::resource('categories', 'Admin\CategoryController');
    Route::resource('units', 'Admin\UnitController');
    Route::resource('products', 'Admin\ProductController');
    Route::resource('inputs', 'Admin\InputController');
    Route::resource('outputs', 'Admin\OutputController');
    Route::resource('clients', 'Admin\ClientController');
    Route::resource('deliveries', 'Admin\DeliveryController');
    Route::resource('cashcuts', 'Admin\CashcutController');
    Route::resource('materials', 'Admin\MaterialController');
    Route::get('deliveries_credit', 'Admin\DeliveryController@deliveryCredit')->name('deliveries.credit.index');
    Route::get('deliveries_normal', 'Admin\DeliveryController@deliveryNormal')->name('deliveries.normal.index');
    //Exports
    Route::get('productsExport', 'Admin\ProductController@productsExport')->name('products.export');
    Route::post('productsImport', 'Admin\ProductController@productsImport')->name('products.import');
    //ProductsSupply
    Route::get('productsSupply', 'Admin\ProductController@productsSupply')->name('products.supply');  
    Route::get('deliveriescredit', 'Admin\DeliveryController@getDeliveriesCredit')->name('deliveries.credit');  
    Route::get('products/sold/filter', 'Admin\ProductController@soldFilter')->name('products.sold.filter');
     
});

routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('login', 'Auth\LoginController@showLoginForm')->name('login');
Route::post('login', 'Auth\LoginController@login');
Route::post('logout', 'Auth\LoginController@logout')->name('logout');
 
Route::group(['middleware' => ['auth', 'app.menu']], function () {    
    Route::get('/', 'Admin\HomeController@index')->name('home');
});

app/Models/Client.php
<?php

namespace App\Models;


class Client extends Model
{
    protected $fillable = [
        'id', 'longname', 'direction','phone','name_store','location','status','city'
    ];


    public $rules = [
        'longname' => 'required|max:200',
        'direction'=>'required|max:200',
        'phone'=>'required|numeric',
        'name_store'=>'required|max:200',
        'status'=>'required',
        'city'=>'required|max:200'
    ];

    protected $casts = [
        'location' => 'json',
        'created_at' => 'datetime'
    ];
}

app/Http/Controllers/Admin/ClientController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use DataTables;
use App\Models\Role;
class ClientController extends Controller
{
    protected $resourceName = 'clients';
    protected $resourceClass = \App\Models\Client::class;
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct() {}    

    
    
}

app/Http/Controllers/Api/ClientController.php
<?php

namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Validator;
use DataTables;


class ClientController extends Controller
{
    protected $resourceName = 'clients';

    protected $resourceClass = \App\Models\Client::class;
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        

    }

    public function datatables() {
        $items = $this->resourceClass::orderDesc()->get();        
        $datatable = DataTables::collection($items);
        $this->columns($datatable);
        $datatable->rawColumns(['actions']);
        return $datatable->make(true);
    }

    private function columns(&$datatable) {
        $datatable->editColumn('status', function ($item) {
                return __('general.' . ($item->status ? 'active' : 'inactive'));
            })->editColumn('created_at', function ($item) {
                return $item->created_at->format("d/m/Y H:i");
            })->editColumn('actions', function ($item) {
            return view('common.actions', [
                "edit" => true,
                "routeEdit" => route("admin.$this->resourceName.edit", ['client' => $item->id]),
            ])->render();
        });
    }

    public function store(Request $request) {
        $item = $this->resourceClass::make($request->all());       
        $validator = Validator::make(
          $request->all(),
          $item->rules ? $item->rules : [],[]
        );   
            
        if($validator->fails()) {
          return response()->json($validator->errors()->toArray(), 400);
        }
            
        if ($item->save()) { 
          return response()->json(["message" => __('control.clientSuccess')]);  
        }
     return response()->json(["error" => true, "message" => __('control.clientError')]);  
    }

    public function update(Request $request,$id) {
        
        $item = $this->resourceClass::find($id);      
        
            
        //$item->id = \Uuid::generate(4)->string;
        $values = $request->all();        
        if ($item->update($values)) { 
          return response()->json(["message" => __('control.clientUpdate')]);  
        }
     return response()->json(["error" => true, "message" => __('control.clientUpdateError')]);  
    }
}

resources/views/admin/clients/form.blade.php
<div class="row">
    @include('common.input', [
        "id" => "longname",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('general.longname'),
        "value" => (isset($item->longname) ? $item->longname : old('longname'))
    ])
    @include('common.input', [
        "id" => "direction",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('general.direction'),
        "value" => (isset($item->direction) ? $item->direction : old('direction'))
    ])
    
</div>
<div class="row">
    @include('common.input', [
        "id" => "city",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('general.city'),
        "value" => (isset($item->city) ? $item->city : old('city'))
    ])
    @include('common.input', [
        "id" => "phone",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('general.phone'),
        "value" => (isset($item->phone) ? $item->phone : old('phone'))
    ])
    
</div>
<div class="row">
    @include('common.input', [
        "id" => "name_store",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('general.name_store'),
        "value" => (isset($item->name_store) ? $item->name_store : old('name_store'))
    ])
    
    @include('common.select', [
        "id" => "status",
        "clas" => "col-md-6",
        "label" => __('general.datatables.status'),
        "options" => [
            "1" => __('general.active'),
            "0" => __('general.inactive'),
        ],
        "value" => (isset($item->status) ? $item->status : old('status'))
    ])
    
    
</div>
<div class="row">
    @if(isset($item) && !isset($item->location))
        @include('common.label', [
            "id" => "location",
            "type"=>"text",
            "clas" => "col-md-6",
            "label" => __('general.location'),
            "value" => __('general.hasnolocation',["name_store"=>$item->name_store])
        ])
    @endif
   
</div>

resources/views/admin/clients/index.blade.php
@extends('layouts.app')

@section('content')
    @parent
    <x-content>
        <x-slot name="title">@lang('general.administration', ['model' => __('navigation.menu.clients')])</x-slot>
        <div class="row py-4">
            <div class="col-md-12">
                <a href="{{ route('admin.clients.create') }}" class="btn btn-outline-primary float-right"><i class="fas fa-plus"></i> @lang('general.add')</a>
                <a href="{{ route('home') }}" class="btn btn-outline-dark"><i class="fas fa-long-arrow-alt-left"></i> @lang('general.cancel')</a>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                @include('common.table', [
                    "resource" => "clients",
                    "headers" => [
                        "longname" => __('general.longname'),
                        "direction" => __('general.direction'),
                        "city" => __('general.city'),
                        "phone" => __('general.phone'),
                        "status" => __('general.datatables.status'),
                        "created_at" => __('general.datatables.created_at'),
                        "actions" => __('general.datatables.actions'),
                    ],
                    "url" => route('api.clients.datatables')
                ])
            </div>
        </div>
    </x-content>
@endsection

resources/views/admin/clients/item.blade.php
@extends('layouts.app')

@section('content')
    @parent
    <x-content>
        <x-slot name="title">{{ __('general.' . (isset($item) ? 'edit' : 'add')) }} @lang('general.client')</x-slot>
        <div class="row py-4">
            <div class="col-md-12">
                @component('components.form', [
                    "item" => (isset($item) ? $item : null),
                    "resource" => "clients",
                    "back" => route('admin.clients.index'),
                    "updateResource" => "client"
                ])
                @include('admin.clients.form', ['item' => (isset($item) ? $item : null)])
                @endcomponent
            </div>
        </div>        
    </x-content>
@endsection